#ifndef _ICM_SIG_H_
#define _ICM_SIG_H_

/*
 * Definition of type signature codes
 */

/* Primitive type signature */
typedef enum {
    number_sig='N',		/* Any number */
    symbol_sig='s',		/* Symbol */
    string_sig='S',		/* String */
    handle_sig='h',		/* Handle object */
    logical_sig='l',		/* Logical value */
    var_sig='$',		/* Type variable */
    unknown_sig='A',		/* Any value -- of unknown type */
    opaque_sig='O',		/* An opaque value, has an owner and a value */

/* Compound type signatures */
    list_sig='L',		/* List pair -- NULL = nil */
    tuple_sig='T',		/* Tuple - followed by length byte */
    query_sig='?',		/* Fielded value */
    forall_sig=':',		/* universally quantified formula */

/* user-defined type signatures */

    usr_sig = 'u',		/* define a new user type */
    poly_sig = 'U',		/* polymorphic user type */

/* Code signatures */
    funct_sig='F',		/* Function object signature */
    proc_sig='P',		/* Procedure signature */
} typeSignature;

/*
 * Type signatures used by the icm itself ...
 */
#define ICM_MSG_OPTS "Lu'msgAttr#552680811'"

#endif

