/***********************************************************************
(c) 1994-1999 Imperial College, F.G. McCabe  and Fujitsu Labs

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Library General Public
License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Library General Public License for more details.

You should have received a copy of the GNU Library General Public
License along with this library; if not, write to the
Free Software Foundation, Inc., 59 Temple Place - Suite 330,
Boston, MA  02111-1307, USA.

Contact: fgm@fla.fujitsu.com
***********************************************************************/

/*
 * Private versions of malloc etc so we can watch what is going on better
 */

#include "config.h"		/* Invoke configuration header */
#include "icmP.h"
#include "icmM.h"
#include <string.h>

#if DMALLOC
#include <dmalloc.h>
#endif

#ifdef MEMTRACE
icmTruth traceMem = icmNo;
#endif

void *icmMalloc(size_t size)
{
  return malloc(size);
}

void *icmCalloc(size_t count,size_t size)
{
  return memset(icmMalloc(count*size),0,count*size);
}

void icmFree(void *ptr)
{
  free(ptr);
}

void *icmRealloc(void *ptr,size_t size)
{
  return realloc(ptr,size);
}
