/***********************************************************************
(c) 1994-1999 Imperial College, F.G. McCabe  and Fujitsu Labs

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Library General Public
License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Library General Public License for more details.

You should have received a copy of the GNU Library General Public
License along with this library; if not, write to the
Free Software Foundation, Inc., 59 Temple Place - Suite 330,
Boston, MA  02111-1307, USA.

Contact: fgm@fla.fujitsu.com
***********************************************************************/

/*
 * Option processing function -- included since some OSes dont have getopt 
 */
#include "config.h"		/* Invoke configuration header */
#include <stdlib.h>
#include <string.h>
#include "icm.h"
#include "icmFile.h"
#include "icmP.h"

int icmGetOptions(int argc,char **argv,char *fmt,icmOptionCallback opt,void *client)
{
  int i;

  initICMIo();			/* Just in case its not been done already */

  for(i=1;i<argc;i++){
    char *optarg = argv[i];	/* pick up the next option */

    if(optarg!=NULL && *optarg=='-'){

      optarg++;			/* Step over the leading - */

      while(*optarg!='\0'){
	char c=*optarg++;

	if(c=='L'){		/* Define the standard log file */
	  if(*optarg=='\0')
	    optarg=argv[++i];
	  if(strcmp(optarg,"-")==0)
	    icmLogFile = OpenStdout();
	  else if(strcmp(optarg,"+")==0)
	    icmLogFile = icmSyslog(argv[0]);
	  else
	    icmLogFile = newOutfile(optarg);
	  break;
	}
	else{
	  char *cs = strchr(fmt,c);

	  if(cs!=NULL){		/* We have a valid option */
	    if(*(cs+1)==':'){	/* It expects an argument */
	      if(*optarg=='\0')	/* The next argument */
		optarg = argv[++i];
	      if(opt!=NULL)
		opt(c,optarg,client); /* Call the callback */
	      break;		/* dont process remaining part of optarg */
	    }
	    else if(opt!=NULL)
	      opt(c,NULL,client);	/* No option argument */
	  }
	  else if(strcmp(optarg,"-")==0)
	    return i+1;		/* return the remaining arguments */
	  else
	    return -1;		/* invalid option */
	}
      }
    }
    else
      return i;
  }
  return argc;			/* we process all the arguments */
}
