/***********************************************************************
(c) 1994-1999 F.G. McCabe, Imperial College and Fujitsu Labs
Hash table interface

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Library General Public
License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Library General Public License for more details.

You should have received a copy of the GNU Library General Public
License along with this library; if not, write to the
Free Software Foundation, Inc., 59 Temple Place - Suite 330,
Boston, MA  02111-1307, USA.

Contact: fgm@fla.fujitsu.com
***********************************************************************/
#ifndef _ICMHASH_H_
#define _ICMHASH_H_

/* Hash table interface */
typedef struct _hashtable_ *icmHashPo;

typedef unsigned long (*icmHashFun)(void *); /* Hashing function */
typedef long (*icmCompFun)(void *, void *); /* Comparison function */
typedef icmStatus (*icmDestFun)(void *, void *); /* Destroy function */
typedef icmStatus (*icmProcFun)(void *n, void *r, void *c); /* Processing func */

/* Build a new hash table */
icmHashPo icmNewHash(long size,icmHashFun hash,icmCompFun cmp,icmDestFun dest);
icmStatus icmDelHash(icmHashPo hp);
icmStatus icmProcessTable(icmProcFun pr,icmHashPo tbl,void *c);

icmStatus icmInstall(void *name, void *r,icmHashPo htbl); /* install a new entry */
void *icmSearch(void *name,icmHashPo htbl); /* search for an entry */
icmStatus icmUninstall(void *name,icmHashPo htbl); /* remove an entry from the hash table */



#endif


