/*
 * This function is compiled only if the system does not have a memory move
 * function
 * An important constraint of this is that it should work even if the 
 * memory ranges overlap
 */
#include <stdlib.h>

void *memmove(void *dest,void *src,size_t n)
{
  register char *s1 = (char *)dest;
  register char *s2 = (char *)src;
  register long count = (long)n;

  if(s1>=s2 && s2+n>=s1){	/* They overlap? */
    s1+=count;
    s2+=count;

    while(count--)
      *--s1=*--s2;
  }
  else{
    while(count--)
      *s1++=*s2++;
  }
  return;
}
