/***********************************************************************
(c) 1994-1999 Imperial College, F.G. McCabe  and Fujitsu Labs

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Library General Public
License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Library General Public License for more details.

You should have received a copy of the GNU Library General Public
License along with this library; if not, write to the
Free Software Foundation, Inc., 59 Temple Place - Suite 330,
Boston, MA  02111-1307, USA.

Contact: fgm@fla.fujitsu.com
***********************************************************************/

/*
 * Handle outgoing messages from an agent
 * These are simply transmitted to the communications server
 */

#include "config.h"		/* Invoke configuration header */
#include <stdlib.h>

#include "icmP.h"		/* Private interface to the ICM */

/* Send an ICM message */
icmStatus icmSendMsg(icmConn conn,icmHandle recip,icmHandle sndr,icmOption opts,
		     icmMsg msg)
{
  long out_pos = 0;
  icmMsg actual = icmFormatMsg(NULL,"%(%h%h%O%#%)",recip,sndr,opts,msg);
  icmStatus ret;

#ifdef COMMTRACE
  if(traceMsg)
    icmLogMsg("%d: send message %M to %h",pthread_self(),msg,recip);
#endif

  while(out_pos<actual->used){
    long ln;

    switch(outBlck(conn->conn,&actual->data[out_pos],actual->used-out_pos,&ln)){
    case icmError:
      icmLogMsg("problem in sending message to %h",recip);
      icmReleaseMsg(actual);
      return icmError;		/* We couldnt send the message */
    case icmFailed:		/* We have to try again */
      continue;
    case icmOk:
      out_pos += ln;
      continue;
    case icmEndFile:
      icmReleaseMsg(actual);
      return icmEndFile;	/* unlikely to happen */
    }
  }
  icmReleaseMsg(actual);
  if((ret=flushFile(conn->conn))==icmError||ret==icmEndFile)
    return ret;
  else
    return icmOk;
}




