#!/bin/bash
#
# icm boot-time startup script
#
# chkconfig: 2345 55 25
# description: ICM daemon forwards messages to compatible agents.

# source function library
. /etc/rc.d/init.d/functions

ICMCFG=/etc/sysconfig/icm

case "$1" in
  start)
	echo -n "Starting icm services: "
	if [ -f "$ICMCFG" ]; then
		. "$ICMCFG"
	else
		echo "(icm is not configured)"
		ICMLOG="-L/var/log/icm.log"
	fi

	daemon /opt/icm/bin/icm $ICMLOG $ICMOPTIONS
	echo
	touch /var/lock/subsys/icm
	;;
  stop)
	echo -n "Shutting down icm services: "
	killproc icm
	rm -f /var/lock/subsys/icm
	echo
	;;
  restart|reload)
	$0 stop
	$0 start
	;;
  status)
	status icm
	;;
  *)
	echo "Usage: icm {start|stop|status|restart|reload}"
	exit 1
esac

exit 0

