/***********************************************************************
(c) 1998-1999 F.G. McCabe, Imperial College and Fujitsu Labs

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Library General Public
License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Library General Public License for more details.

You should have received a copy of the GNU Library General Public
License along with this library; if not, write to the
Free Software Foundation, Inc., 59 Temple Place - Suite 330,
Boston, MA  02111-1307, USA.

Contact: fgm@fla.fujitsu.com
***********************************************************************/

#ifndef _ICMFILE_H_
#define _ICMFILE_H_


#include "icmIo.h"			/* io management system interface */

extern filePo icmLogFile;		/* We can write to this to log a message */
extern filePo stdIn;			/* We can read from here for user responses */
extern filePo stdOut;
extern filePo stdErr;

typedef icmStatus (*fileProc)(filePo f,int cl);

/* File level I/O functions */
filePo icmOpenInFile(char *);		/* Open file for input */
filePo icmOpenOutfile(char *file);		/* open file for output */
filePo icmOpenInOutFile(char *file); 	/* open file for output */
filePo icmOpenAppendFile(char *file);	/* open file for append-only output */
filePo icmOpenInOutAppendFile(char *file);	/* open file for append-only output */
filePo icmNewOutfile(char *file);		/* create file for output */
filePo icmLocateFile(char *name);		/* Search for a file ... */
icmStatus icmCloseFile(filePo);		/* Close file */
filePo icmOpenStdin(void);			/* Unix specific */
filePo icmOpenStdout(void);		/* Unix specific */
filePo icmOpenStderr(void);		/* Unix specific */
filePo icmSyslog(char *ident);	        /* Logging file */

filePo openInFile(char *);		/* Open file for input */
filePo openOutfile(char *file);		/* open file for output */
filePo openInOutFile(char *file); 	/* open file for output */
filePo openAppendFile(char *file);	/* open file for append-only output */
filePo openInOutAppendFile(char *file);	/* open file for append-only output */
filePo newOutfile(char *file);		/* create file for output */
filePo locateFile(char *name);		/* Search for a file ... */
icmStatus closeFile(filePo);		/* Close file */
filePo OpenStdin(void);			/* Unix specific */
filePo OpenStdout(void);		/* Unix specific */
filePo OpenStderr(void);		/* Unix specific */
filePo icmSyslog(char *ident);	        /* Logging file */

icmStatus openPipe(char *exec,char **argv,char **envv,filePo *inpipe,filePo *outpipe);
icmStatus seekFile(filePo f,long where,long mode);
icmStatus waitforIo(fileProc filter,void *fcl,fileProc trigger,void *tcl,long tout);

icmStatus filePresent(char *name); 	/* True if file exists */

void setup_stdin(void);		/* Set up stdin to non-blocking mode */
void reset_stdin(void);		/* Reset to normal mode */

#endif
