/***********************************************************************
(c) 1998-1999 F.G. McCabe, Imperial College and Fujitsu Labs

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Library General Public
License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Library General Public License for more details.

You should have received a copy of the GNU Library General Public
License along with this library; if not, write to the
Free Software Foundation, Inc., 59 Temple Place - Suite 330,
Boston, MA  02111-1307, USA.

Contact: fgm@fla.fujitsu.com
***********************************************************************/
/*
 * Header file for standard socket interface
 */
#ifndef _ICM_SOCK_H_
#define _ICM_SOCK_H_

#include <sys/types.h>
#ifdef WIN32
#include <winsock.h>
#else
#include <sys/socket.h>
#include <netinet/in.h> 
#include <arpa/inet.h>
#endif

typedef struct _ip_port_ {	/* An internet connection identifier */
  struct in_addr ip;		/* The ip number -- will have to extend for IPv6 */
  short port;			/* Port number of the connection */
} icmIpPort;
    
filePo listeningPort(char *name,int port);
filePo acceptConnection(filePo listen,icmStatus *res);
char *peerName(filePo stream,int *port);
char *peerIP(filePo stream,int *port);
filePo icmConnectRemote(char *where,int port,icmStatus *ret,
			char *retmsg,long retlen);
filePo connectRemote(char *where,int port,icmStatus *ret);
icmIpPort icmPeerAddr(filePo stream);


#endif
