/*
  Accept secured connections -- using /etc/hosts.allow and /etc/hosts.deny

  (c) 2000 F.G.McCabe

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

  Contact: Francis McCabe <fgm@fla.fujitsu.com>
 */

#include "config.h"
#include "daemon.h"		/* Our data structures etc. */
#include <stdlib.h>		/* Standard functions */
#include <assert.h>		/* debugging assertions */

#ifdef HAVE_LIBWRAP
#include "tcpd.h"

int allow_severity = 0;
int deny_severity = 0;
int severity_option = 0;
int alloc_severity = 0;

extern char *our_name;

filePo acceptSecuredConnection(filePo listen,icmStatus *res)
{
  filePo conn = acceptConnection(listen,res);

  if(*res==icmOk){		/* verify the connection is from allowed host */
    struct request_info info;
    struct sockaddr_in cli_addr;
    int cli_len = sizeof(cli_addr);
    int sock = (int)fileData(conn);
    char cli_addr_str[32];

    getpeername(sock,(struct sockaddr*)&cli_addr,&cli_len);
    icmIPToStr(&cli_addr.sin_addr, cli_addr_str,NumberOf(cli_addr_str));

    request_init(&info,RQ_FILE,icmFileData(conn),RQ_DAEMON,"icm",
		 RQ_CLIENT_ADDR, cli_addr_str,0);

    if(hosts_access(&info))
      return conn;
    else{
      if(res!=NULL)
	*res = icmFailed;
      icmCloseFile(conn);
      return NULL;
    }
  }
  else
    return conn;
}
#else
#ifndef WIN32
#warning Host access control not implemented
#endif
filePo acceptSecuredConnection(filePo listen,icmStatus *res)
{
  return acceptConnection(listen,res);
}
#endif

