# Note that this is a partially relocatable package (IYKWYAD)

Summary:	The Interagent Communications Model server and library
Name:		icm
Version:	0.5.0
Release:	1
Copyright:	GPL
Group:		System Environment/Daemons
Source:		icm-0.5.0.tar.gz
Obsoletes:	icm

Packager:	Francis G. McCabe <fgm@fla.fujitsu.com>
URL:		http://www.nar.fujitsulabs.com/icm/ 
Prefix:		/scratch/install/icm
Docdir:		/scratch/install/icm/doc
BuildRoot:	/var/tmp/icm-0.5.0-root

%description

The ICM is a server and API library that implements a messaging system
that is tailored to the needs of distributed agent systems.

Some of the key features and benefits of this model are:

A store and forward architecture which allows truly asynchronous
communication between agents: the receiver agent need not be on-line
when a message is sent to it.

Messages are encoded in an efficient structured way; permitting lists,
tuples, strings, program code and circular structures to be
represented.

The self-parsing nature of the encoding permits open and extensible
forms of communication without requiring the use of predefined message
format information to be compiled into applications. It also permits
additional message oriented services to be added to the ICM.

Minimizes the use of system resources by allowing multiple
applications on a host to share a single communications server.

Globally unique agent handles permits the ICM to route messages
without requiring that every agent platform has the skill to route all
forms of message.

Handle aliasing helps to manage agent migration in a well controlled
straightforward way.

Virtual hosts allow the use of intermittently connected devices such
as Personal Digital Assistants and dial-up computers, in a way that is
largely transparent to individual agent platforms and agent
applications.

%prep
%setup 

%build
./configure --sysconfdir=/etc
make

%install
rm -rf $RPM_BUILD_ROOT
make prefix=$RPM_BUILD_ROOT%{prefix} sysconfdir=$RPM_BUILD_ROOT/etc install 

%clean
rm -rf $RPM_BUILD_ROOT

%package devel
Summary:	ICM core libraries, includes and more.
Group:		Development/Libraries
Requires:	icm

%description devel
Libraries and header files that permit applications to access the ICM
via its API interface

%changelog

*Fri May 19 2000 John Knottenbelt <jak@fla.fujitsu.com>
Changed RPM to build from source

*Fri Dec 17 1999 Francis G. McCabe <fgm@fla.fujitsu.com>
Added documentation about type signatures.

*Tue Nov 30 1999 Francis G. McCabe <fgm@fla.fujitsu.com>
Extended to handle messages with type signatures

*Tue Jun 1 1999 Francis G. McCabe <fgm@fla.fujitsu.com>
First public release of ICM

%files
%defattr(-, root, root)

%{prefix}
/etc/rc.d/init.d/icm
%config /etc/sysconfig

# %doc AUTHORS COPYING ChangeLog NEWS README

%files devel
%defattr(-, root, root)

%{prefix}/lib/lib*.so
%{prefix}/lib/*a
%{prefix}/include/*
